// Bouillon5.pde
// 9 3 2017
// OK Processing 2
// OK Processing 3
//
// Touche A : Allumer
// Touche Q : Couleur pixel Random
// Touche R : Couleur pixel Random Uni
// Touche S : Sauve la fenetre en png
// Touche T : Text coordonnees pixel
// Touche V : Comme un Vu-metre
// Touche Fleche   Up Lumiere ++
// Touche Fleche Down Lumiere --
// 16 x 9 = 144 LEDs 

PImage monImage2;
String monImage2Nom = "TheatreBouillon2.jpg";

int Obscurite = 255;
int TailleLED = 4;
boolean TextePixel = false;
int XLED, YLED;
color[][] Pixel = new color[16][9];

boolean Vum = false; // true  false
int ValVumetre;


void setup() {
  monImage2 = loadImage(monImage2Nom);
  // size(monImage2.width*2, monImage2.height*2);
  size(1232, 600);
  // frameRate(3);
  PixelUni(color(255, 255, 0));
}

void draw() {
  tint(Obscurite);
  image(monImage2, 0, 0, width, height);

  if (Vum) {
    ValVumetre = int(frameCount / 5); // 0 .. 9
    ValVumetre = ValVumetre % 10; // 0 .. 9
    VuMetre(ValVumetre);
  }

  noStroke();
  textSize(10);
  for (int xx = 0; xx < 16; xx = xx+1) {
    for (int yy = 0; yy < 9; yy = yy+1) {
      XLED = xx * width /(36) + 360 + (xx - 7) * 3 * yy;
      YLED = (yy * height / 21) + 110;
      fill(Pixel[xx][yy]); 
      ellipse(XLED, YLED, TailleLED, TailleLED);
      if (TextePixel) text(xx + " " + yy, XLED + 3, YLED + 5);
    }
  }

  fill(255); 
  if (TextePixel) BarreMenu();

  if (keyPressed) {
    if (keyCode == UP)   Obscurite = Obscurite + 1;
    if (keyCode == DOWN) Obscurite = Obscurite - 1;
  }
  if (frameCount < 255) {
    Obscurite = 255 - frameCount;
    BarreMenu();
  }
  if (Obscurite < 0) Obscurite = 0;
  if (Obscurite > 255) Obscurite = 255;
}

void keyReleased() {
  if (key == 'a' || key == 'A') Obscurite = 255;
  if (key == 'v' || key == 'V') Vum = !Vum;
  if (key == 'q' || key == 'Q') {
    Vum = false;
    PixelRandom();
  }
  if (key == 'r' || key == 'R') {
    Vum = false;
    PixelUni(color(random(255), random(255), random(255)));
  }
  if (key == 's' || key == 'S') saveFrame("Screen" + frameCount +".png");
  if (key == 't' || key == 'T') TextePixel = !TextePixel;
}

void PixelUni(color cc) {
  for (int xx = 0; xx < 16; xx = xx+1) {
    for (int yy = 0; yy < 9; yy = yy+1) {
      Pixel[xx][yy] = cc;
    }
  }
}

void PixelRandom() {
  for (int xx = 0; xx < 16; xx = xx+1) {
    for (int yy = 0; yy < 9; yy = yy+1) {
      Pixel[xx][yy] = color(random(255), random(255), random(255));
    }
  }
}

void BarreMenu() {
  text("A Allumer    Q Pixel Random    R Pixel Random Uni    S Sauve fenetre    T Text    V Vu-metre    Fleche Up/Down Lumiere", 10, height - 10);
}

void VuMetre(int ii) { // 0 .. 9
  // ii = 9;
  ii = 9 - ii;
  if (ii < 0) ii = 0;
  if (ii > 9) ii = 9;

  for (int xx = 0; xx < 16; xx = xx+1) {
    for (int yy = 0; yy < 9; yy = yy+1) {
      if (yy > ii - 1) Pixel[xx][yy] = color(255 - (yy - ii) * 30);
      else Pixel[xx][yy] = color(0);
    }
  }
}

